//
//  AppDelegate.m
//  TabViewAndAutoLayout
//
//  Created by narita on 2015/02/11.
//  Copyright (c) 2015年 narita. All rights reserved.
//

#import "AppDelegate.h"
#import "MTLSPreferencesWinodwController.h"
#import "NSObject(MTLSControlItemEnabler).h"
#import "MTLSUserDefaults.h"
#import "MTLColor2HTMLColor.h"


@interface AppDelegate ()

@end

@implementation AppDelegate

#pragma mark -
#pragma mark class methods

+ (void)restoreWindowWithIdentifier:(NSString *)identifier
                              state:(NSCoder *)state
                  completionHandler:(void (^)(NSWindow *, NSError *))completionHandler
{
    NSWindow *window = nil;
    
    if ([identifier isEqualToString:@"PreferencesWinodw"])
    {
        AppDelegate *appDelegate = (AppDelegate*)[NSApp delegate];
        
        window = [[appDelegate preferencesWindowController] window];
    }
    
    completionHandler(window, nil);
}

#pragma mark -
#pragma mark init methods

- (id) init
{
    self = [super init];
    
    if( self )
    {
        [NSUserDefaults setupDefaults];
                
        [NSValueTransformer setValueTransformer:[[MTLColor2HTMLColor alloc] init]
                                        forName:@"MTLColor2HTMLColor"];
        [NSValueTransformer setValueTransformer:[[MTLHTMLColor2Color alloc] init]
                                        forName:@"MTLHTMLColor2Color"];
    }
    
    return self;
}

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark action and canAction methods

- (IBAction) showPreferences:(id)sender
{
    NSWindowController* theWC = [self preferencesWindowController];
    
    [theWC showWindow:self];
}

- (BOOL) canShowPreferences
{
    return YES;
}

#pragma mark -
#pragma mark delegate/datasource methods

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
}

- (void)applicationWillTerminate:(NSNotification *)aNotification
{
    // Insert code here to tear down your application
}

#pragma mark -
#pragma mark accessor methods (in pairs)

#pragma mark -
#pragma mark Utility methods

- (MTLSPreferencesWinodwController*) preferencesWindowController
{
    MTLSPreferencesWinodwController* theWC = [MTLSPreferencesWinodwController sharedInstance];
    
    theWC.window.restorationClass = [self class];
    
    return theWC;
}

- (BOOL)validateUserInterfaceItem:(id<NSValidatedUserInterfaceItem>)anItem
{
    BOOL theResult = YES;
    
    [self respondsAndPerformAnyUtility:(id)anItem];
    
    if([self respondsToCanSelector:[anItem action]])
    {
        theResult = [self performCanSelector:[anItem action]];
    }
    
    return theResult;
}

@end
