//
//  MTLColor2HTMLColor.m
//  HTMLColor
//
//  Created by narita on 08/03/25.
//  Copyright 2008 MindTools Inc. All rights reserved.
//

#import "MTLColor2HTMLColor.h"


@implementation MTLColor2HTMLColor

+ (Class)transformedValueClass
{
    return [NSString class];
}

+ (BOOL)allowsReverseTransformation
{
    return YES;
}

- (id)transformedValue:(id)value
{
    NSString* str;
    
    if(value != nil && [value isKindOfClass:[NSColor class]])
    {
        NSInteger r   = [value redComponent]   * 255.0f;
        NSInteger g   = [value greenComponent] * 255.0f;
        NSInteger b   = [value blueComponent]  * 255.0f;
        
        str = [NSString stringWithFormat:@"#%02lx%02lx%02lx", (long)r, (long)g, (long)b];
    }
    else
    {
        str = @"#000000";
    }
    
    return str;
}

- (id)reverseTransformedValue:(id)value
{
    NSColor* theResult;
    
    NSString* str = value;
    
    // #で始まる
    if([str hasPrefix:@"#"] && [str length] == 7)
    {
        NSString* r = [str substringWithRange:NSMakeRange(1, 2)];
        NSString* g = [str substringWithRange:NSMakeRange(3, 2)];
        NSString* b = [str substringWithRange:NSMakeRange(5, 2)];
        
        unsigned int red;
        unsigned int green;
        unsigned int blue;
        
        [[NSScanner scannerWithString:r] scanHexInt:&red];
        [[NSScanner scannerWithString:g] scanHexInt:&green];
        [[NSScanner scannerWithString:b] scanHexInt:&blue];
        
        theResult = [NSColor colorWithCalibratedRed: (float) red / 255.0f
                                              green: (float) green / 255.0f
                                               blue: (float) blue / 255.0f
                                              alpha:1.0];
    }
    else
    {
        NSLog(@"reverseTransformedValue Err");
        
        theResult = [NSColor blackColor];
    }
    
    return theResult;
}

@end;


@interface MTLHTMLColor2Color ()
@property (strong) MTLColor2HTMLColor* color2HTML;
@end

@implementation MTLHTMLColor2Color

- (id) init
{
    self = [super init];
    
    if(self)
    {
        _color2HTML = [[MTLColor2HTMLColor alloc] init];
    }
    
    return self;
}

+ (Class)transformedValueClass
{
    return [NSColor class];
}

+ (BOOL)allowsReverseTransformation
{
    return YES;
}

- (id)transformedValue:(id)value
{
    return [self.color2HTML reverseTransformedValue:value];
}

- (id)reverseTransformedValue:(id)value
{
    return [self.color2HTML transformedValue:value];
}

@end