//
//  MTLSPreferencesWinodw.m
//  TabViewAndAutoLayout
//
//  Created by narita on 2015/02/11.
//  Copyright (c) 2015年 narita. All rights reserved.
//

#import "MTLSPreferencesWinodw.h"
#import "NSObject(MTLSControlItemEnabler).h"
//#import "MTLSUserDefaults.h"

@implementation MTLSPreferencesWinodw

#pragma mark -
#pragma mark class methods

#pragma mark -
#pragma mark init methods

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

- (void) close
{
    // NSTextFieldなどのCommitが必要なControl対策
    [self  makeFirstResponder:nil];
    
    [super close];
}

#pragma mark -
#pragma mark action and canAction methods

- (IBAction) cancelOperation:(id)sender
{
    [self close];
}

- (BOOL) canCancelOperation
{
    return YES;
}

- (IBAction) toggleToolbarShown:(id)sender
{
    // 実行しない
}

- (BOOL) canToggleToolbarShown
{
    // メニューやボタンをDisableにする
    return NO;
}


#pragma mark -
#pragma mark delegate/datasource methods

#pragma mark -
#pragma mark accessor methods (in pairs)

#pragma mark -
#pragma mark Utility methods

- (BOOL)validateUserInterfaceItem:(id<NSValidatedUserInterfaceItem>)anItem
{
    BOOL theResult = YES;
    
    [self respondsAndPerformAnyUtility:(id)anItem];
    
    if([self respondsToCanSelector:[anItem action]])
    {
        theResult = [self performCanSelector:[anItem action]];
    }
    else if( [[self superclass] instancesRespondToSelector:@selector(validateUserInterfaceItem:)] == YES)
    {
        theResult = [super validateUserInterfaceItem:anItem];
    }
    
    return theResult;
}

@end
