//
//  MTLSUserDefaults.m
//  Expenses
//
//  Created by narita on 08/03/04.
//  Copyright 2008 MindTools Inc. All rights reserved.
//

#import "MTLSUserDefaults.h"

@implementation NSUserDefaults (MTLSUserDefaults)

+ (void)setupDefaults
{
    NSString *userDefaultsValuesPath;
    NSDictionary *userDefaultsValuesDict;
    
    // ユーザデフォルトに使用するデフォルト値を読み込む
    userDefaultsValuesPath=[[NSBundle mainBundle] pathForResource:@"UserDefaults" 
														   ofType:@"plist"];
    if( userDefaultsValuesPath )
    {
        userDefaultsValuesDict=[NSDictionary dictionaryWithContentsOfFile:userDefaultsValuesPath];

        if( userDefaultsValuesDict )
        {
            // 読み込んだ値を標準ユーザデフォルトに設定
            [[NSUserDefaults standardUserDefaults] registerDefaults:userDefaultsValuesDict];
            [[NSUserDefaultsController sharedUserDefaultsController] setInitialValues:userDefaultsValuesDict];
        }
    }
}

@end

